<template>
    <div class="investors-filter">
        <base-filter :params="filterParams"
            v-model="filterData"
            :pickerOptions="pickerOptions"
            @apply="initFilter"
            @reset="resetFilter"
        >
            <download-csv-btn slot="btns-after" :filter="filterData" list-type="investors"/>
        </base-filter>
    </div>
</template>

<script>
import { investorsFilterSettings, defaultInvestorsFilter } from '@/constants/ui/filters';
import { mapState } from 'vuex';
import filterMixin from '@/mixins/filterMixin';
import BaseFilter from './baseFilter';
import DownloadCsvBtn from '@/components/DownloadCsvBtn';

export default {
    name: 'investorsFilter',
    components: {
        BaseFilter,
        DownloadCsvBtn,
    },
    mixins: [filterMixin],
    data() {
        return {
            filterSettings: investorsFilterSettings,
            filterData: defaultInvestorsFilter,
        };
    },
    computed: {
        ...mapState({
            serverFilter: state => state.users.investors_filter,
        }),
    },
    methods: {
        /** Apply new investor filter params */
        initFilter() {
            this.initLoading(this.$store.dispatch('filterInvestorsList', this.filterData));
        },
        /** Reset current investor filter params */
        resetFilter() {
            this.filterData = { ...defaultInvestorsFilter };
            this.$store.commit('clearInvestorsFilter');
        },
    },
};
</script>
